-- KingMe, by Cidrei (Jazrei of Zangarmarsh-US)

-- Locals
local version = "30000.1"
local chatprefix = "!kingme"
local KingMe = {}

function KingMe.OnEvent()
	if event == "ADDON_LOADED" and arg1 == "KingMe" then
		SLASH_KINGME1 = "/kingme"
		SlashCmdList["KINGME"] = KingMe.ChatCommandHandler
		KingMe.SavedVars()
	elseif KingMeSV["On"] and event == "CHAT_MSG_WHISPER" then
		KingMe.PassCrown(arg1, arg2)
	end
end

function KingMe.SavedVars()
	if KingMeSV == nil then
		KingMeSV = {}
	end
end

function KingMe.PassCrown(prefix, name)
	if prefix == chatprefix then
		if IsPartyLeader() == 1 then
			PromoteToLeader(name)
		else
			SendChatMessage("KingMe: "..UnitName("player").." is not the party leader.", "WHISPER", nil, name)
		end
	else
		return
	end
end

-- Command parsing by tigerheart. Rest in peace, man.
function KingMe.GetCommand(msg)
 	if msg then
 		local a,b,c = strfind(msg, "(%S+)")
 		if a then
 			return c, strsub(msg, b+2)
 		else	
 			return ""
 		end
 	end
 end

function KingMe.ChatCommandHandler(msg)
	local cmd, subcmd = KingMe.GetCommand(msg)
	if cmd == "toggle" then
		if not KingMeSV["On"] then
			KingMeSV["On"] = 1
			KingMe.Print("KingMe: |cffff2020Enabled")
		else
			KingMeSV["On"] = nil
			KingMe.Print("KingMe: |cffff2020Disabled")
		end
	else
		local status = ""
		if KingMeSV["On"] then
			status = "|cffff2020Enabled|cff20ff20"
		else
			status = "|cffff2020Disabled|cff20ff20"
		end
		KingMe.Print("KingMe v"..version..": "..status.."\n/kingme toggle - Toggles KingMe on or off. Default is off.")
	end
end

function KingMe.Print(msg) 
	if not DEFAULT_CHAT_FRAME then
		return
	end
	DEFAULT_CHAT_FRAME:AddMessage("|cff20ff20"..msg)
end

-- Need a frame to attach to.
local f = CreateFrame("Frame")
f:RegisterEvent("ADDON_LOADED")
f:RegisterEvent("CHAT_MSG_WHISPER")
f:SetScript("OnEvent", KingMe.OnEvent)
